AppTitle "The Girl"

Graphics3D 0,0, 32, 1

;Graphics3D 800,600, 32, 2

Global camSize = GraphicsHeight()


Const cPlayerSpeed# = .08
Const cMouseSensitivity# = .3
Const cShadowProj# 	= .4
Const cTombStones	= 4


Const cMeshes     	= 20
Const MESH_FENCE  	= 1
Const MESH_BASE  	= 2
Const MESH_COLUMN 	= 3
Const MESH_STONE	= 4
Const MESH_GRAVE_ANG= 10
Const MESH_GRAVE  	= 11
Const MESH_TOMB		= 12
Const MESH_TOMB_REF	= 13




Global pointLight, dirLight, player, world
Global shadowCaster




Global gMeshCaster
Global gMeshReceiver
Global gMeshShadow
Global gMeshPlane
Global gMeshPlaneAdd

Global gFont1 = LoadFont("", 20)
Global gFont2 = LoadFont("", 30, 1)




Dim gMesh(cMeshes)




SetBuffer BackBuffer()
SeedRnd MilliSecs()




texGrass  = LoadTexture("grass.jpg")
texCobble = LoadTexture("cobble.jpg")
texMask   = LoadTexture("mask.png")
texDark   = LoadTexture("dark.png")
texStone  = LoadTexture("stone.jpg")
texMetal  = LoadTexture("metal.jpg")
texGrave  = LoadTexture("grave.jpg")
texMarble = LoadTexture("marble.jpg")



player = CreatePivot()



cam = CreateCamera( player )

CameraViewport cam, GraphicsWidth()/2 - camSize/2, 0, camSize, camSize


;CameraRange cam, 10, 10000


CameraZoom cam, 10

PositionEntity cam, 0, 30, 2
RotateEntity cam, 90,0,0






;letter

texLetter = LoadTexture("letter.png")
letter = LoadMesh("quad.3ds")
EntityFX letter, 1
EntityOrder letter, 1
EntityTexture letter, texLetter

PositionEntity letter, 0,-20,2


RenderWorld
Flip


WaitKey()

FreeEntity letter



;game


AmbientLight 0,0,0

pointLight = CreateLight(2, player)
PositionEntity pointLight, 0,2,0 
LightRange pointLight, 5



dirLight = CreateLight(1)
RotateEntity dirLight, 45, 30, 0
LightColor dirLight, 30, 30, 60





playerLight = CreatePivot()
quad = LoadMesh("quad.3ds", playerLight)
;ScaleMesh quad, 8.8, 2, 11.2
ScaleMesh quad, 2.6, 2, 3.4
PositionEntity quad, 0,0,4.2
lightTex = LoadTexture("flash.png", 1+16+32)


PositionTexture lightTex, 1.5, 1.5
ScaleTexture lightTex, .25, .25



EntityTexture quad, lightTex 
EntityFX quad, 1
EntityOrder quad, 2
EntityBlend quad, 2







PositionEntity player, 38,0,-22
RotateEntity player, 0, 90, 0



world = CreatePivot()


CreateWorld()




EntityFX gMeshPlane, 1
EntityTexture gMeshPlane, texMask, 	0, 1
EntityTexture gMeshPlane, texCobble,0, 2
EntityTexture gMeshPlane, texGrass, 0, 3
TextureBlend texCobble, 2
ScaleTexture texCobble, .01, .01
TextureBlend texGrass, 3
ScaleTexture texGrass, .1, .1



gMeshPlaneAdd = CopyEntity(gMeshPlane)
EntityBlend gMeshPlaneAdd, 3
EntityTexture gMeshPlaneAdd, texDark, 0, 4
TextureBlend texDark, 2





EntityTexture gMesh(MESH_GRAVE), texGrave
EntityTexture gMesh(MESH_GRAVE_ANG), texGrave
EntityTexture gMesh(MESH_COLUMN), texStone
EntityTexture gMesh(MESH_BASE), texStone
EntityTexture gMesh(MESH_STONE), texMarble
EntityTexture gMesh(MESH_TOMB), texMarble
EntityTexture gMesh(MESH_FENCE), texMetal




Sphere = CreateSphere(16,player)
ScaleMesh sphere, .3,.3,.3


	;HideEntity world

timer = CreateTimer(60)

;reset mouse cursor	to screen center
MoveMouse GraphicsWidth()/2, GraphicsHeight()/2
	
	
	
	
EntityPickMode gMesh(MESH_GRAVE), 2
EntityPickMode gMesh(MESH_GRAVE_ANG), 2

picker = CreatePivot(player)
PositionEntity picker, 0,5,0.4
RotateEntity picker, 90,0,0
	
	
	
FlushMouse()
FlushKeys()

Repeat

	If Not GameOver Then MovePlayer(player)


	;reset mouse cursor	to screen center
	MoveMouse GraphicsWidth()/2, GraphicsHeight()/2


	CopyPosRot(player, playerlight)

	
	
	
	
	;shadow calculateion
	For i = 1 To CountChildren(gMeshShadow)
		If GetChild(gMeshCaster,i) = gMesh(MESH_TOMB) Then
			;CalculateShadow(gMesh(MESH_TOMB_REF), gMeshTombShadow)
			HideEntity GetChild(gMeshShadow,i)
		Else
			CalculateShadow(GetChild(gMeshCaster,i), GetChild(gMeshShadow,i))
		EndIf
	Next
	
	
	
	;render Point Light
	CameraClsMode cam, 1,1
	
	ShowEntity gMeshPlane
	HideEntity gMeshPlaneAdd
	
	BlendChildren(world, 1)

	HideEntity player
	
	HideEntity dirLight	
	ShowEntity pointLight


	HideEntity quad
	
	ShowEntity gMeshReceiver
	HideEntity gMeshCaster
	ShowEntity gMeshShadow	
	
	
	ShowEntity player
	
	RenderWorld
	
	
	;render light & shadows
	CameraClsMode cam, 0, 0

	HideEntity dirLight	
	ShowEntity pointLight

	HideEntity gMeshPlane
	
	HideEntity gMeshReceiver
	ShowEntity gMeshCaster
	HideEntity gMeshShadow		

	RenderWorld


	HideEntity gMeshReceiver
	HideEntity gMeshCaster
	HideEntity gMeshShadow		

	ShowEntity quad

	RenderWorld
	
	
	
	
	;render world (additive)
	HideEntity pointLight
	ShowEntity dirLight
	
	ShowEntity gMeshReceiver
	ShowEntity gMeshCaster
	
	HideEntity quad
	
	BlendChildren(world, 3)
	
		
	
	ShowEntity gMeshPlaneAdd
	
	RenderWorld
	
	
	If EntityPick(picker, 100) Then 
	

	
		If KeyDown(57) Or GameOver Then
		
			GameOver = True		
			SetFont gFont2
			Color 255,255,255
			If PickedEntity() = gMesh(MESH_GRAVE_ANG) Then
				Text GraphicsWidth()/2, GraphicsHeight()-80, "GameOver. Du konntest den Dmon erfolgreich austreiben.", 1					
			Else
				Text GraphicsWidth()/2, GraphicsHeight()-80, "GameOver. Das war das falsche Grab. Du bist umgekommen.", 1				
			EndIf
			If KeyDown(28) Then End
		Else
			SetFont gFont1
			Color 100,100,150
			Text GraphicsWidth()/2, GraphicsHeight()-30, "<Space> um Exorzismus durchzufhren", 1		
		EndIf
	
	EndIf
	
	WaitTimer timer
	Flip


Until KeyHit(1)


Function MovePlayer(player)

	Local speedMod# = 1
	If KeyDown(32) - KeyDown(30) Then
		If KeyDown(17) - KeyDown(31) Then
			;reduce vertical speed
			speedMod# = .707
	   	EndIf
	EndIf
		

	MoveEntity player, (KeyDown(32) - KeyDown(30))*cPlayerSpeed*speedMod#,0, (KeyDown(17) - KeyDown(31))*cPlayerSpeed*speedMod# 
	TurnEntity player, 0, -MouseXSpeed() * cMouseSensitivity#, 0



End Function



Function CopyPosRot(source, target)

	PositionEntity target, EntityX(source), EntityY(source), EntityZ(source)
	RotateEntity target, EntityPitch(source), EntityYaw(source), EntityRoll(source) 


End Function



Function CalculateShadow(refMesh, shadowMesh)

	Local srcSurf, tarSurf
	Local vertexCount, v, x#, y#, z#
	Local xProj#, zProj#, xDist#, zDist#
	
	If EntityClass$(refMesh) <> "Mesh" Return
	If CountSurfaces(refMesh) < 1 Return
	
	srcSurf = GetSurface(refMesh,1)
	tarSurf = GetSurface(shadowMesh,1)

	vertexCount = CountVertices(srcSurf)-1
	
	For v = 0 To vertexCount
		x# = VertexX#(srcSurf, v)
		y# = VertexY#(srcSurf, v)
		z# = VertexZ#(srcSurf, v)				
	
		xDist# = EntityX#(player) - x#
		zDist# = EntityZ#(player) - z#
	
		xProj# = x# - xDist# * y# * cShadowProj#
		zProj# = z# - zDist# * y# * cShadowProj#
	
		VertexCoords tarSurf, v, xProj#, 0, zProj#
	
	Next


End Function





Function BlendChildren(entity, blendMode)

	Local i, child
	For i = 1 To CountChildren(entity)
	
		child = GetChild(entity, i)
		If EntityClass$(child) <> "Pivot" Then EntityBlend child, blendMode
		BlendChildren(child, blendMode)
		
	Next


End Function




Function CreateWorld()

	Local worldData, instances, i 
	Local fence, references, shadow

	worldData = LoadAnimMesh("cemetery.b3d", world)

	instances  = FindChild(worldData, "Instances")
	references = FindChild(worldData, "OriginalParts")
	
	
	
	For i = 1 To cMeshes
		gMesh(i) = CreateMesh()		
	Next
	
	
	;Stop
	BuildFromInstances(instances, references)		
	
	
	;FreeEntity references
	
	
	gMeshCaster 	= CreatePivot(world)
	gMeshReceiver 	= CreatePivot(world) 
	gMeshShadow     = CreatePivot(world)
	gMeshPlane		= FindChild(worldData, "GroundPlane")
	
	
	EntityParent gMesh(MESH_BASE), gMeshReceiver
	EntityParent gMesh(MESH_GRAVE), gMeshReceiver
	EntityParent gMesh(MESH_GRAVE_ANG), gMeshReceiver
	
	EntityParent gMesh(MESH_FENCE), gMeshCaster
	EntityParent gMesh(MESH_TOMB), gMeshCaster
	EntityParent gMesh(MESH_COLUMN), gMeshCaster
	EntityParent gMesh(MESH_STONE), gMeshCaster
	EntityParent gMesh(MESH_TOMB_REF), gMeshCaster
	


	;create regular shadow mesh
	For i = 1 To CountChildren(gMeshCaster)
		shadow = CopyMesh(GetChild(gMeshCaster,i), gMeshShadow)	
		EntityColor shadow, 0, 0, 0
		EntityOrder shadow, -2
	Next

	
	HideEntity gMESH(MESH_TOMB_REF)	



End Function




Function BuildFromInstances(inst, references, theOne=0)


	Local c, child, childrenCount, parent, ref, angel_num
	
	
	childrenCount = CountChildren(inst)
	
	
	;DebugLog EntityName(inst)
	angel_num = Rand(1,childrenCount) 
	
	
	If childrenCount > 0 Then
	;process children
	For c = 1 To childrenCount
		If c = angel_num Then
			BuildFromInstances(GetChild(inst, c), references, True)
		Else
			BuildFromInstances(GetChild(inst, c), references, False)
		EndIf
	Next

	Else
	;lowest level, these are our actual instances
	parent = GetParent(inst)


	;get reference 
	ref = FindChild(references, EntityName$(parent))
	


	For c = 1 To CountChildren(ref)
	
		child = GetChild(ref, c)
			
		Select EntityName$(child)
			Case "Fence"
				AddInstance(child, inst, gMesh(MESH_FENCE))
			Case "FenceBase"
				AddInstance(child, inst, gMesh(MESH_BASE))
			Case "Grave" 
				If theOne Then
					AddInstance(child, inst, gMesh(MESH_GRAVE_ANG))	
				Else
					AddInstance(child, inst, gMesh(MESH_GRAVE))	
				EndIf
				
			Case "TombBase"
				AddInstance(child, inst, gMesh(MESH_BASE))
			Case "Column"
				AddInstance(child, inst, gMesh(MESH_COLUMN))
			Case "Stone"
				AddInstance(child, inst, gMesh(MESH_STONE))
			Case "TombStone"
				AddInstance(child, inst, gMesh(MESH_TOMB))
				
				
				If theOne Then
					;special tomb stone
					AddInstance(GetChild(FindChild(references, "Angel"),1), inst, gMesh(MESH_TOMB_REF))		
				Else
					;choose one of the regular tomb stones	
					AddInstance(GetChild(GetChild(FindChild(references, "TombStones"),Rand(1,cTombStones)),1), inst, gMesh(MESH_TOMB_REF))
				EndIf
				;AddInstance(child, inst, gMesh(MESH_TOMB_REF))
				;AddInstance(GetChild(FindChild(references, "Angel"),1), inst, gMesh(MESH_TOMB_REF))
					
					
		End Select	
			
	
	Next
	EndIf



End Function




Function AddInstance(source, instance, targetMesh)

	Local mesh = CopyMesh(source)
	
	RotateMesh mesh, 0, EntityYaw(instance), 0
	PositionMesh mesh, EntityX(instance), 0, EntityZ(instance)

	AddMesh(mesh, TargetMesh)

	FreeEntity(mesh)

End Function










